#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <math.h>
#include "csound.hpp"
//#include "csound.h"
#include <iomanip>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctime>
#include <fftw3.h>
#include </home/JCH/Kdev4Projs/DSP/biquad.h> 

#define SIZE 44100
#define N 44102
#define TRUE  1
#define FALSE 0
#define MYCHANNELS 2 
typedef int boolean;

using std::cout;
using std::endl;

using namespace std;
    
    //arrays ptrs for for file I/O and filtering
    double absval;
    double *inputsine;
    double *inputsawtooth;
    double *inputsquare;
    double *inputtriangle;
    double *inputwhitenoise;
    double *inputpinknoise;
    
    //arrays declared as globals
    double inputfiltsine[N];
    double inputfiltsawtooth[N];
    double inputfiltsquare[N];
    double inputfilttriangle[N];
    double inputfiltwhitenoise[N];
    double inputfiltpinknoise[N];
    double input [N];
    double inputfilt [N];
    double buffer_filt[N][MYCHANNELS]; //a 2 ch buffer
    double buffer_unfilt[N][MYCHANNELS]; //a 2 ch buffer
    
    //set the path here for the FILE I/O funcs below
    string path("/home/JCH/Kdev4Projs/DSP/build");
    
//************* BiQuad Filter FUNCTIONS *********
//**********************************************
//**********************************************
/* Simple implementation of Biquad filters -- Tom St Denis
   Based on the work
   Cookbook formulae for audio EQ biquad filter coefficients
---------------------------------------------------------
by Robert Bristow-Johnson, pbjrbj@viconet.com  a.k.a. robert@audioheads.com

   This work is hereby placed in the public domain for all purposes, whether
   commercial, free [as in speech] or educational, etc.  Use the code and please
   give me credit if you wish.
   Tom St Denis -- http://tomstdenis.home.dhs.org
   (Downloaded and adapted from: www.musicdsp.org/files/biquad.c)
   NOTE: biquad.h is also needed.
*/

/* Computes a BiQuad filter on a sample */
double BiQuad(double sample, biquad * b)
{
    double result;
    
    /* compute result */
    result = b->a0 * sample + b->a1 * b->x1 + b->a2 * b->x2 -
        b->a3 * b->y1 - b->a4 * b->y2;

    /* shift x1 to x2, sample to x1 */
    b->x2 = b->x1;
    b->x1 = sample;

    /* shift y1 to y2, result to y1 */
    b->y2 = b->y1;
    b->y1 = result;

    return result;
}

/* sets up a BiQuad Filter */
biquad *BiQuad_new(int type, double dbGain, double freq,
double srate, double bandwidth)
{
    biquad *b;
    double A, omega, sn, cs, alpha, beta;
    double a0, a1, a2, b0, b1, b2;

    b = (biquad*) malloc(sizeof(biquad));
    if (b == NULL)
        return NULL;

    /* setup variables */
    A = pow(10, dbGain /40);
    omega = 2 * M_PI * freq /srate;
    sn = sin(omega);
    cs = cos(omega);
    alpha = sn * sinh(M_LN2 /2 * bandwidth * omega /sn);
    beta = sqrt(A + A);
    
    switch (type) {
    case LPF:
        b0 = (1 - cs) /2;
        b1 = 1 - cs;
        b2 = (1 - cs) /2;
        a0 = 1 + alpha;
        a1 = -2 * cs;
        a2 = 1 - alpha;
        break;
    case HPF:
        b0 = (1 + cs) /2;
        b1 = -(1 + cs);
        b2 = (1 + cs) /2;
        a0 = 1 + alpha;
        a1 = -2 * cs;
        a2 = 1 - alpha;
        break;
    case BPF:
        b0 = alpha;
        b1 = 0;
        b2 = -alpha;
        a0 = 1 + alpha;
        a1 = -2 * cs;
        a2 = 1 - alpha;
        break;
    case NOTCH:
        b0 = 1;
        b1 = -2 * cs;
        b2 = 1;
        a0 = 1 + alpha;
        a1 = -2 * cs;
        a2 = 1 - alpha;
        break;
    case PEQ:
        b0 = 1 + (alpha * A);
        b1 = -2 * cs;
        b2 = 1 - (alpha * A);
        a0 = 1 + (alpha /A);
        a1 = -2 * cs;
        a2 = 1 - (alpha /A);
        break;
    case LSH:
        b0 = A * ((A + 1) - (A - 1) * cs + beta * sn);
        b1 = 2 * A * ((A - 1) - (A + 1) * cs);
        b2 = A * ((A + 1) - (A - 1) * cs - beta * sn);
        a0 = (A + 1) + (A - 1) * cs + beta * sn;
        a1 = -2 * ((A - 1) + (A + 1) * cs);
        a2 = (A + 1) + (A - 1) * cs - beta * sn;
        break;
    case HSH:
        b0 = A * ((A + 1) + (A - 1) * cs + beta * sn);
        b1 = -2 * A * ((A - 1) + (A + 1) * cs);
        b2 = A * ((A + 1) + (A - 1) * cs - beta * sn);
        a0 = (A + 1) - (A - 1) * cs + beta * sn;
        a1 = 2 * ((A - 1) - (A + 1) * cs);
        a2 = (A + 1) - (A - 1) * cs - beta * sn;
        break;
    default:
        free(b);
        return NULL;
    }

    /* precompute the coefficients */
    b->a0 = b0 /a0;
    b->a1 = b1 /a0;
    b->a2 = b2 /a0;
    b->a3 = a1 /a0;
    b->a4 = a2 /a0;

    /* zero initial samples */
    b->x1 = b->x2 = 0;
    b->y1 = b->y2 = 0;
   
    //print coefficients
    printf("a0 = %15.10f\n", a0);
    printf("a1 = %15.10f\n", a1); 
    printf("a2 = %15.10f\n", a2); 
    printf("b0 = %15.10f\n", b0); 
    printf("b1 = %15.10f\n", b1); 
    printf("b2 = %15.10f\n", b2); 

    return b;
}
//---------------------------------------
#define M_SQR(x) ((x)*(x))

//double BiQuad_response(double freq, double srate, biquad *p)
void BiQuad_response(double freq, double srate, biquad *p)
{
    int i ;
    double sum_dry2 = 0, sum_wet2  = 0;
    FILE *outf1;
    
    p->x1 = p->x2 = 0;
    p->y1 = p->y2 = 0;
      
    string freqRespAppend ("/freqresp.dat");
    string freqRespPath = path + freqRespAppend;
    outf1=fopen(freqRespPath.c_str(),"w");
    
    for(i = 1 ; i < srate ; i++) {
	double x = sin(2.0*M_PI*freq/srate*(double)i) ;
	double y ;
	sum_dry2 += x*x ;
	y = BiQuad(x, p) ;
	sum_wet2 += y*y ;
	fprintf(outf1, "%4.20f\n", sqrt(sum_wet2/sum_dry2));
    }
    fclose(outf1);

}


//************* SOUND SAMPLE FUNCTIONS *********
//******************waves and noise*************
//**********************************************
double sine(double D, double i, double f, int num, double A) 
{
       double pi = 4 * atan(1.0);
       return A * (sin(2 * pi * i / D * f * num));
}

double sawtooth(double D, double i, double f, int num, double A) 
{
       double sawtooth;
return sawtooth  = A * (2 * (double(num)/double(D/f) - (double(floor((double(num)/double(D/f)) + 0.5)))));
}

double square (double D, double i, double f, int num, double A) 
{
       double pi = 4 * atan(1.0);
       double x = sin(2 * pi * i / D * f * num);
       double mysquare;
       return mysquare = A * ((x > 0) - (x < 0));
}

double triangle(double D, double i, double f, int num, double A) 
{	
       double triangle;
       return triangle  = A * (fabs(2 * (double(num)/double(D/f) - (double(floor((double(num)/double(D/f)) + 0.5))))));
}

//************* SOUND SAMPLE FUNCTIONS Csound *********
//*****************************************************
//*****************************************************
/*There is no notion of time here while constructing one full buffer 
  which would be repeated at the krate.
  (For pitch using spin, the frequency is the krate (SR/ksmps).
  myksmps is only the granularity, since that buffer will be
  performed at the krate)
*/
//    these funcs create one cycle of the waveform over the specified
//    number of ksmps which will then be repeated at the krate yielding
//    a frequency of the krate when using spin.
   
double sine_C(int num, int theksmps, double A) 
{
       double pi = 4 * atan(1.0);
      return A * (sin(2 * pi * 1 / theksmps * num));
}

double square_C (int num, int theksmps, double A) 
{
       double pi = 4 * atan(1.0);
       double x = sin(2 * pi * 1 / theksmps * num);
       double mysquare;
       return mysquare = A * ((x > 0) - (x < 0));
}

double sawtooth_C(int num, int theksmps, double A) 
{
       double sawtooth;
return sawtooth  = A * (2 * (double(num)/double(theksmps) - (double(floor((double(num)/double(theksmps)) + 0.5)))));
}

double triangle_C(int num, int theksmps, double A) 
{
       double triangle;
       return triangle  = A * (fabs(2 * (double(num)/double(theksmps) - (double(floor((double(num)/double(theksmps)) + 0.5))))));
}
//----------------
/* For whitenoise to work with addspinsample
   there needs to be higher number of samples
   ex. 8192 in the file or generated using the function, 
   and the ksmps and SR of the .csd
   needs to be 8192, and 16384 respectively.

   But for sine, square, triangle, and sawtooth
   sample generation, the buffer will work with
   a small number of samples, ex. 210 and a higher
   SR 44100.
*/ 
//...from audacity srcs
float whitenoise(int num, double A)
{
   float div = ((float)RAND_MAX) / 2.0f;
   float anum;
   anum   = (rand() / div) - 1.0;
   return anum * A;
}
//...code created from emails on DSP Music list
// re: Paul Kellet's post on pink noise, and ensuing comments.
//http://www.musicdsp.org/showArchiveComment.php?ArchiveID=76
float pinknoise(int num, double srate, double A)
{

   float white, pink, amplitude; 
   float f0,f1, f2, f3, f4, f5, f6;
   float k0,k1, k2, k3, k4, k5, k6;
   float b0,b1, b2, b3, b4, b5, b6;
   double pi = 4 * atan(1.0);
   float div = ((float)RAND_MAX) / 2.0f;
   
   white=f0=f1=f2=f3=f4=f5=f6=0;
   
   white   = (rand() / div) - 1.0;

  float trc = 1.0;
  double sr = srate*trc;

  //f0-f6 - freq array in hz
  //
  //---------------------
  //samplerate <= 48100hz
  if (sr <= 48100){
  f0 = 4752.456;
  f1 = 4030.961;
  f2 = 2784.711;
  f3 = 1538.461;
  f4 = 357.681;
  f5 = 70;
  f6 = 30;
  }
  //---------------------
  //samplerate > 44800hz && samplerate <= 96000hz
  else if (sr > 48000 && sr <= 96000) {
  f0 = 8227.219;
  f1 = 8227.219;
  f2 = 6388.570;
  f3 = 3302.754;
  f4 = 479.412;
  f5 = 151.070;
  f6 = 54.264;
  }
  //---------------------
  //samplerate > 96000khz && samplerate < 192000khz
  else if(sr > 96000 && sr < 192000){
  f0 = 9211.912;
  f1 = 8621.096;
  f2 = 8555.228;
  f3 = 8292.754;
  f4 = 518.334;
  f5 = 163.712;
  f6 = 240.241;
  }
  //---------------------
  //samplerate >= 192000hz
  else {
  f0 = 10000;
  f1 = 10000;
  f2 = 10000;
  f3 = 10000;
  f4 = 544.948;
  f5 = 142.088;
  f6 = 211.616;
  }
  //----------------------
  //calculate coefficients
  k0 = exp(-2*pi*f0/sr);
  k1 = exp(-2*pi*f1/sr);
  k2 = exp(-2*pi*f2/sr);
  k3 = exp(-2*pi*f3/sr);
  k4 = exp(-2*pi*f4/sr);
  k5 = exp(-2*pi*f5/sr);
  k6 = exp(-2*pi*f6/sr);

  //--- sample loop ---
  //white - noise input
  b0 = k0*white+k0*b0;
  b1 = k1*white+k1*b1;
  b2 = k2*white+k2*b2;
  b3 = k3*white+k3*b3;
  b4 = k4*white+k4*b4;
  b5 = k5*white+k5*b5;
  b6 = k6*white+k6*b6;
  pink = (b0+b1+b2+b3+b4+b5+white-b6) * A;

  return pink;
   
}
//************* FILE I/O FUNCTIONS *************
//*********for graphing data with gnuplot***********
//**********************************************
void timeDomain(double D, double i, double f, double srate, double A, int type)
{
// calls sound sample funcs.
// Does not write data to a file.
switch (type) {
    case MYSIN:
      inputsine=new double [N];
for (int s=0;s<SIZE;s++) {
    inputsine[s] = sine(D, i, f, s, A);
  }
        break;
    case SAW:
      inputsawtooth=new double [N];
for (int s=0;s<SIZE;s++) {
    inputsawtooth[s] = sawtooth(D, i, f, s, A);
  }
        break;
    case SQ:
      inputsquare=new double [N];
for (int s=0;s<SIZE;s++) {
    inputsquare[s] = square(D, i, f, s, A);
  }
        break;
    case TRI:
      inputtriangle=new double [N];
for (int s=0;s<SIZE;s++) {
    inputtriangle[s] = triangle(D, i, f, s, A);
  }
        break;
    case NOISEW:
      inputwhitenoise=new double [N];
for (int s=0;s<SIZE;s++) {
    inputwhitenoise[s] = whitenoise(s, A);
  }
        break;
    case NOISEP:
      inputpinknoise=new double [N];
for (int s=0;s<SIZE;s++) {
    inputpinknoise[s] = pinknoise(s, srate, A);
  }
        break;
    default:
        break;
    } //end switch
}
 
void DCoffset_timedomainSignal(double f,int type)
{
//********Seeks a zero crossing,
//and determines if dc offset present,
//then writes TIME DOMAIN DATA to td_sig.dat
//for use with gnuplot.
//********
string tdSigAppend ("/td_sig.dat");
string tdSigPath = path + tdSigAppend;
FILE *outf2;
outf2=fopen(tdSigPath.c_str(),"w");

    float d, dc;
    float mymax = 0.0;
    float mymin = 0.0;
    int num, samplenum, periodnum;
    num = 0;
    float x1, x2, xc;
    samplenum = 0;

//Calcs a period number which is est to be stable
//after filter startup costs.  Uses an even numbered
//period (phase), and !<2.
    periodnum = (int)(0.005 * f);
    if(periodnum%2==1){
      periodnum = periodnum+1;
    }
    if (periodnum < 2){
      periodnum = 2;
    }

    switch (type) {
      case MYSIN:
//Calcs the sample number (samplenum) at the
//zero crossing (periodnum), above
      for (int s=0;s<SIZE/4;s++) {  //SIZE/4 should be enough
	x1 = inputsine[s];
	x2 = inputsine[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){ //zero crossing number
		num = s+1; 
	      }
	  }
      }
//Searches from stable zero crossing to find min and max
//for determining if DC offset present
      for (int s=num;s<SIZE;s++) {
	if(inputsine[s] > mymax){
	  mymax = inputsine[s];
	}
	if(inputsine[s] <= mymin){
	  mymin = inputsine[s];
	}
      }
		
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
//attempts to remove DC offset
      for (int s=0;s<SIZE;s++) {
	inputsine[s] = inputsine[s] - dc;
	//print filtered signal minus any DC offset
	fprintf(outf2, "%4.20f\n", inputsine[s]);
      }
    break;
    case SAW:
      for (int s=0;s<SIZE/4;s++) { 
	x1 = inputsawtooth[s];
	x2 = inputsawtooth[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){
		num = s+1; 
	      }
	  }
      }
      for (int s=num;s<SIZE;s++) {
	if(inputsawtooth[s] > mymax){
	  mymax = inputsawtooth[s];
	}
	if(inputsawtooth[s] <= mymin){
	  mymin = inputsawtooth[s];
	}
      }
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
      for (int s=0;s<SIZE;s++) {
	inputsawtooth[s] = inputsawtooth[s] - dc;
	fprintf(outf2, "%4.20f\n", inputsawtooth[s]);
      }
    break;
    case SQ:
      for (int s=0;s<SIZE/4;s++) { 
	x1 = inputsquare[s];
	x2 = inputsquare[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){
		num = s+1; 
	      }
	  }
      }
      for (int s=num;s<SIZE;s++) {
	if(inputsquare[s] > mymax){
	  mymax = inputsquare[s];
	}
	if(inputsquare[s] <= mymin){
	  mymin = inputsquare[s];
	}
      }
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
      for (int s=0;s<SIZE;s++) {
	inputsquare[s] = inputsquare[s] - dc;
	fprintf(outf2, "%4.20f\n", inputsquare[s]);
    }
    break;
    case TRI:      
      for (int s=0;s<SIZE/4;s++) { 
	x1 = inputtriangle[s];
	x2 = inputtriangle[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){
		num = s+1; 
	      }
	  }
      }
      for (int s=num;s<SIZE;s++) {
	if(inputtriangle[s] >  mymax){
	  mymax = inputtriangle[s];
	}
	if(inputtriangle[s] <= mymin){
	  mymin = inputtriangle[s];
	}
      }
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
      for (int s=0;s<SIZE;s++) {
	inputtriangle[s] = inputtriangle[s] - dc;
	fprintf(outf2, "%4.20f\n", inputtriangle[s]);
    }  
    break;
    case NOISEW:
//No DC offset checking with noise.
	for (int s=0;s<SIZE;s++) {
	  fprintf(outf2, "%4.20f\n", inputwhitenoise[s]);
	}
    break;
    case NOISEP:
      for (int s=0;s<SIZE;s++) {
	  fprintf(outf2, "%4.20f\n", inputpinknoise[s]);
	}
    break;
    default:
    break;
    } //end switch
    
   //extra printing for DC offset error checking	
   fprintf(outf2, "# ---------\n");
   fprintf(outf2,"# Start Period: %d, " "dc: %4.20f, " "mymax: %4.20f, " "mymin: %4.20f\n", num, dc, mymax, mymin); 
    
  fclose(outf2);
}

void timeDomain_filterSignal(double D, double i, double f, double srate, double A, biquad *bq, int type)
{
// Filters the time domain data arrays by calling the filter function
// Does not write data to file.

/*
 * To process audio samples, call double BiQuad(double sample, biquad * b)
 * for each audio sample
 */       
    float myfiltnum; 

  switch (type) {
    case MYSIN:
	for (int s=0;s<SIZE;s++) {   
	  myfiltnum = BiQuad(inputsine[s], bq);
	  inputfiltsine[s]= myfiltnum;
	}
        break;
    case SAW:
	for (int s=0;s<SIZE;s++) {  
	  myfiltnum = BiQuad(inputsawtooth[s], bq);
	  inputfiltsawtooth[s]= myfiltnum;
	}
        break;
    case SQ:
	for (int s=0;s<SIZE;s++) {  
	  myfiltnum = BiQuad(inputsquare[s], bq);
	  inputfiltsquare[s]= myfiltnum;
	}
        break;
    case TRI:
	for (int s=0;s<SIZE;s++) { 
	  myfiltnum = BiQuad(inputtriangle[s], bq);
	  inputfilttriangle[s]= myfiltnum;
	}
        break;
    case NOISEW:
	for (int s=0;s<SIZE;s++) {  
	  myfiltnum = BiQuad(inputwhitenoise[s], bq);
	  inputfiltwhitenoise[s]= myfiltnum;
	}
        break;
    case NOISEP:
	for (int s=0;s<SIZE;s++) {   
	  myfiltnum = BiQuad(inputpinknoise[s], bq);
	  inputfiltpinknoise[s]= myfiltnum;
	}
        break;
    default:
        break;
    } //end switch 
    
}

void DCoffset_filteredSignal(double f,int type){
//********Seeks a zero crossing,
//and determines if dc offset present,
//then prints a time domain filtered signal for use 
//with gnuplot.
//Does not smooth any corrupted, initial filter samples.
//********
string tdFiltSigAppend ("/td_filtsig.dat");
string tdFiltSigPath = path + tdFiltSigAppend;
FILE *outf3;
outf3=fopen(tdFiltSigPath.c_str(),"w");

    float d, dc;
    float mymax = 0.0;
    float mymin = 0.0;
    int num, samplenum, periodnum;
    num = 0;
    float x1, x2, xc;
    samplenum = 0;

//Calcs a period number which is est to be stable
//after filter startup costs.  Uses an even numbered
//period (phase), and !<2.
    periodnum = (int)(0.005 * f);
    if(periodnum%2==1){
      periodnum = periodnum+1;
    }
    if (periodnum < 2){
      periodnum = 2;
    }

    switch (type) {
      case MYSIN:
//Calcs the sample number (samplenum) at the
//zero crossing (periodnum), above
      for (int s=0;s<SIZE/4;s++) {  //SIZE/4 should be enough
	x1 = inputfiltsine[s];
	x2 = inputfiltsine[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){ //zero crossing number
		num = s+1; 
	      }
	  }
      }
//Searches from stable zero crossing to find min and max
//for determining if DC offset present
      for (int s=num;s<SIZE;s++) {
	if(inputfiltsine[s] > mymax){
	  mymax = inputfiltsine[s];
	}
	if(inputfiltsine[s] <= mymin){
	  mymin = inputfiltsine[s];
	}
      }
		
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
//attempts to remove DC offset
      for (int s=0;s<SIZE;s++) {
	inputfiltsine[s] = inputfiltsine[s] - dc;
	//print filtered signal minus any DC offset
	fprintf(outf3, "%4.20f\n", inputfiltsine[s]);
      }
    break;
    case SAW:
      for (int s=0;s<SIZE/4;s++) { 
	x1 = inputfiltsawtooth[s];
	x2 = inputfiltsawtooth[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){
		num = s+1; 
	      }
	  }
      }
      for (int s=num;s<SIZE;s++) {
	if(inputfiltsawtooth[s] > mymax){
	  mymax = inputfiltsawtooth[s];
	}
	if(inputfiltsawtooth[s] <= mymin){
	  mymin = inputfiltsawtooth[s];
	}
      }
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
      for (int s=0;s<SIZE;s++) {
	inputfiltsawtooth[s] = inputfiltsawtooth[s] - dc;
	fprintf(outf3, "%4.20f\n", inputfiltsawtooth[s]);
      }
    break;
    case SQ:
      for (int s=0;s<SIZE/4;s++) { 
	x1 = inputfiltsquare[s];
	x2 = inputfiltsquare[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){
		num = s+1; 
	      }
	  }
      }
      for (int s=num;s<SIZE;s++) {
	if(inputfiltsquare[s] > mymax){
	  mymax = inputfiltsquare[s];
	}
	if(inputfiltsquare[s] <= mymin){
	  mymin = inputfiltsquare[s];
	}
      }
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
      for (int s=0;s<SIZE;s++) {
	inputfiltsquare[s] = inputfiltsquare[s] - dc;
	fprintf(outf3, "%4.20f\n", inputfiltsquare[s]);
    }
    break;
    case TRI:
      for (int s=0;s<SIZE/4;s++) { 
	x1 = inputfilttriangle[s];
	x2 = inputfilttriangle[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	    samplenum = samplenum++;
	      if (samplenum == periodnum){
		num = s+1; 
	      }
	  }
      }
      for (int s=num;s<SIZE;s++) {
	if(inputfilttriangle[s] > mymax){
	  mymax = inputfilttriangle[s];
	}
	if(inputfilttriangle[s] <= mymin){
	  mymin = inputfilttriangle[s];
	}
      }
      d = (mymax - mymin)/2.0;
      dc = mymax - d;
      for (int s=0;s<SIZE;s++) {
	inputfilttriangle[s] = inputfilttriangle[s] - dc;
	fprintf(outf3, "%4.20f\n", inputfilttriangle[s]);
    }
    break;
    case NOISEW:
//No DC offset checking with noise.
	for (int s=0;s<SIZE;s++) {
	  fprintf(outf3, "%4.20f\n", inputfiltwhitenoise[s]);
	}
    break;
    case NOISEP:
      for (int s=0;s<SIZE;s++) {
	  fprintf(outf3, "%4.20f\n", inputfiltpinknoise[s]);
	}
    break;
    default:
    break;
    } //end switch
    
   //extra printing for DC offset error checking	
   fprintf(outf3, "# ---------\n");
   fprintf(outf3,"# Start Period: %d, " "dc: %4.20f, " "mymax: %4.20f, " "mymin: %4.20f\n", num, dc, mymax, mymin); 
    
  fclose(outf3);
//*****************************
}

void prepFFT(double D, double i, double f, double srate, double A, int type, biquad *bq)
{
// Place the non-filt timedomain data in an array
// of SIZE + 2 (padded zeros) for FFT (input[]).
// Also places the filtered timedomain data which has been
// thru DC offset to another array, also of SIZE + 2 (inputfilt[]).
  switch (type) {
    case MYSIN:
  for (int s=0;s<N;s++) {
	  input[s] = inputsine[s];
	  //inputfiltsine has been thru DC offset func.
	  inputfilt[s] = inputfiltsine[s];    
 }	  
        break;
    case SAW:
  for (int s=0;s<N;s++) {
	  input[s] = inputsawtooth[s];
	  inputfilt[s] = inputfiltsawtooth[s];
  }
        break;
    case SQ:
  for (int s=0;s<N;s++) {
	  input[s] = inputsquare[s];
	  inputfilt[s] = inputfiltsquare[s];
  }
        break;
    case TRI:
  for (int s=0;s<N;s++) {
	  input[s] = inputtriangle[s];
	  inputfilt[s] = inputfilttriangle[s];
  }
        break;
    case NOISEW:
  for (int s=0;s<N;s++) {
	  input[s] = whitenoise(s, A);
	  //noise has not been thru DC offset func.
	  inputfilt[s]= BiQuad(input[s], bq);
    }
        break;
    case NOISEP:
  for (int s=0;s<N;s++) {
	  input[s] = pinknoise(s,srate, A);
	  inputfilt[s]= BiQuad(input[s], bq);
    }
        break;
    default:
        break;
    } //end switch
}

void windowSignal(biquad *bq)
{
//Prints a windowed sig for both nonfiltered and
//filtered signals, minus any DC offset.
string tdWinfiltSigAppend ("/td_filtsigWindowed.dat");
string tdWinfiltSigPath = path + tdWinfiltSigAppend;
string tdWinunfiltSigAppend ("/td_unfiltsigWindowed.dat");
string tdWinunfiltSigPath = path + tdWinunfiltSigAppend;
FILE *outf4, *outf5;
outf4=fopen(tdWinunfiltSigPath.c_str(),"w");
outf5=fopen(tdWinfiltSigPath.c_str(),"w");


for (int j=0;j<N;j++){
//BLACKMAN
//input and inputfilt are global arrays filled
//in prepFFT() above.
//...this is the array multiplied by the window
  input[j] = input[j] *(0.42 - 0.5 * cos (2.0*M_PI*(double)j/(double)(N-1))
  + 0.08 * cos (4.0*M_PI*(double)j/(double)(N-1)) );

  fprintf(outf4, "%5.6f \n", input[j]);
	  
  inputfilt[j] = inputfilt[j]*(0.42 - 0.5 * cos (2.0*M_PI*(double)j/(double)(N-1))
  + 0.08*cos (4.0 * M_PI*(double)j/(double)(N-1)) );

  fprintf(outf5, "%5.6f \n", inputfilt[j]);
}
fclose(outf4);
fclose(outf5);
}

void performDFT(biquad *bq)
{
//perform DFT using FFTW3 
fftw_plan plan_forward, plan_forwardfilt, plan_backward;
int n = N;//44102

/*
Here, n is the “logical” size of the DFT, not necessarily the physical size of the array. In particular, the real (double) array has n elements, while the complex (fftw_complex) array has n/2+1 elements (where the division is rounded down). For an in-place transform, in and out are aliased to the same array, which must be big enough to hold both; so, the real array would actually have 2*(n/2+1) elements, where the elements beyond the first n are unused padding.[FFTW3 Manual, re: r2c plan] Thus the minimum size of n should be 2*((N/2)+1).
NOTE--however, a num much larger than SR value causes the fundamental to shift.
*/

fftw_complex* in = (fftw_complex*)fftw_malloc(sizeof(fftw_complex)*n);
fftw_complex* out = (fftw_complex*)fftw_malloc(sizeof(fftw_complex)*n);
fftw_complex* infilt = (fftw_complex*)fftw_malloc(sizeof(fftw_complex)*n);
fftw_complex* outfilt = (fftw_complex*)fftw_malloc(sizeof(fftw_complex)*n);
fftw_complex* invout = (fftw_complex*)fftw_malloc(sizeof(fftw_complex)*n);
  
//also does backward transform as check, if needed.
plan_forward = fftw_plan_dft_1d(n, in, out, FFTW_FORWARD, FFTW_ESTIMATE);
plan_backward = fftw_plan_dft_1d(n, in, invout, FFTW_BACKWARD, FFTW_ESTIMATE);
plan_forwardfilt = fftw_plan_dft_1d(n, infilt, outfilt, FFTW_FORWARD, FFTW_ESTIMATE);

//uses global prepFFT array 'input' from prepFFT func,
//as well as 'inputfilt'.
//in and infilt arrays are filled AFTER creating the plan.
  for(int j=0;j<n+1;j++)
  { in[j][0] = input[j];
    in[j][1] = 0.0;
    infilt[j][0] = inputfilt[j];
    infilt[j][1] = 0.0;
  }
  
fftw_execute(plan_forward);

//*******************
//to print U N F I L T E R E D FFT forward data to a file
string tdfreqsAppend ("/fd_freqs.dat");
string tdfreqsPath = path + tdfreqsAppend;
FILE *outf6;
outf6=fopen(tdfreqsPath.c_str(),"w");

//LINEAR SCALE
//for(int j= 0;j<(N/2)+1;j++){
//can use either below for printing of positive, real values.
//fprintf(outf5, "%d\t%5.6f\t%5.6f \n", j, fabs(out[j][0]), out[j][1]);
//fprintf(outf5, "%d\t%5.6f\t%5.6f \n", j, sqrt(pow(out[j][0],2) + pow(out[j][1],2)));
//}

//LOG SCALE
for(int j=0;j<(N/2)+1;j++){
//fprintf(outf6, "%d\t%5.6f\t%5.6f \n", j, 20 * log10(fabs(out[j][0])), 20 * log10(fabs(out[j][1])));
fprintf(outf6, "%d\t%5.6f\t%5.6f \n", j, 20 * log10(sqrt(pow(out[j][0],2) + pow(out[j][1],2))));
}

fclose(outf6);
//*******************
//to print U N F I L T E R E D Reverse FFT data to a file
//as a check
/*
fftw_execute(plan_backward);
string tdfreqsRevAppend ("/fd_freqsBackward.dat");
string tdfreqsRevPath = path + tdfreqsRevAppend;
FILE *outf11;
outf11=fopen(tdfreqsRevPath.c_str(),"w");

for(int j= 0;j<(N/2)+1;j++){
fprintf(outf11, "%d\t%5.6f\t%5.6f \n", j, fabs(invout[j][0]), invout[j][1]);
}
fclose(outf11);
*/
//*******************
//to print F I L T E R E D FFT forward data to a file
string tdfiltfreqsAppend ("/fd_filtfreq.dat");
string tdfiltfreqsPath = path + tdfiltfreqsAppend;
FILE *outf7;
outf7=fopen(tdfiltfreqsPath.c_str(),"w");

fftw_execute(plan_forwardfilt);

for(int j=0;j<(N/2)+1;j++){
outfilt[j][0] = 20 * log10(sqrt(pow(outfilt[j][0],2) + pow(outfilt[j][1],2))); 
fprintf(outf7, "%d\t%5.6f \n", j, outfilt[j][0] );
}

fclose(outf7);
fftw_destroy_plan(plan_forward);
fftw_destroy_plan(plan_forwardfilt);
fftw_destroy_plan(plan_backward);
fftw_free(in);
fftw_free(out);
fftw_free(infilt);
fftw_free(outfilt);
fftw_free(invout);
}

//************* Fill Csound buffer *************
//*********for rendering file thru .csd*********
//**********************************************
// Loads one cycle or period of the UNFILTERED data into a buffer
// for csound
void csoundBufUnfiltered(double D,double i,double f,double srate,double A,int period,int type)
{
string Csd_tdLAppend ("/Csound_tdL.dat");
string Csd_tdLPath = path + Csd_tdLAppend;
string Csd_tdRAppend ("/Csound_tdR.dat");
string Csd_tdRPath = path + Csd_tdRAppend;
FILE *outf8, *outf9;
outf8=fopen(Csd_tdLPath.c_str(),"w");
outf9=fopen(Csd_tdRPath.c_str(),"w");

int j, k;

 switch (type) {
    case MYSIN:
      for(j=0;j<period;j++){
	for(k=0;k<MYCHANNELS;k++){
buffer_unfilt[j][k] = sine(D, i, f, j, A);  //unfiltered sine
/* could also load just one buffer suitable for csound ksmps
   by using the xxxx_C funcs. But be sure myksmps is set accordingly
   buffer_unfilt[j][k] = sine_C(j, period, A);
*/

	  if(k%2==0){
fprintf(outf9, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	  if(k%2==1){
fprintf(outf8, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	}//ends k for
      }//ends j for
        break;
    case SAW:
      for(j=0;j<period;j++){
	for(k=0;k<MYCHANNELS;k++){
buffer_unfilt[j][k] = sawtooth(D, i, f, j, A);  //unfiltered sawtooth
	  if(k%2==0){
fprintf(outf9, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	  if(k%2==1){
fprintf(outf8, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	}//ends k for
      }//ends j for
        break;
    case SQ:
      for(j=0;j<period;j++){
	for(k=0;k<MYCHANNELS;k++){
buffer_unfilt[j][k] = square(D, i, f, j, A);  //unfiltered square
	  if(k%2==0){
fprintf(outf9, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	  if(k%2==1){
fprintf(outf8, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	}//ends k for
      }//ends j for
        break;
    case TRI:
      for(j=0;j<period;j++){
	for(k=0;k<MYCHANNELS;k++){
buffer_unfilt[j][k] = sawtooth(D, i, f, j, A);  //unfiltered triangle
	  if(k%2==0){
fprintf(outf9, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	  if(k%2==1){
fprintf(outf8, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	}//ends k for
      }//ends j for
        break;
    case NOISEW:
      for(j=0;j<period;j++){
	for(k=0;k<MYCHANNELS;k++){
buffer_unfilt[j][k] = whitenoise(j, A);  //unfiltered whitenoise
	  if(k%2==0){
fprintf(outf9, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	  if(k%2==1){
fprintf(outf8, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	}//ends k for
      }//ends j for
        break;
    case NOISEP:
      for(j=0;j<period;j++){
	for(k=0;k<MYCHANNELS;k++){
buffer_unfilt[j][k] = pinknoise(j,srate, A);  //unfiltered pinknoise
	  if(k%2==0){
fprintf(outf9, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	  if(k%2==1){
fprintf(outf8, "%5.4f \n", buffer_unfilt[j][k]);
	  }
	}//ends k for
      }//ends j for
        break;
    default:
        break;
    } //end switch
    
fclose(outf8);
fclose(outf9);
}

void csoundBufFiltered(double D,double i,double f,double A,int period,int type)
{
// Extracts one cycle or period of time domain FILTERED data
// from the inputfiltsawtooth (ex.) buffer using a portion of
// SIZE and places the period into a csound 
// buffer for use in comparison of output of .csd.
string Csd_tdFilt_LAppend ("/Csound_tdFilt_L.dat");
string Csd_tdFilt_LPath = path + Csd_tdFilt_LAppend;
string Csd_tdFilt_RAppend ("/Csound_tdFilt_R.dat");
string Csd_tdFilt_RPath = path + Csd_tdFilt_RAppend;
FILE *outf10, *outf11;
outf10=fopen(Csd_tdFilt_LPath.c_str(),"w");
outf11=fopen(Csd_tdFilt_RPath.c_str(),"w");

int j,k;
int num, samplenum, periodnum;
num = 0;
float x1, x2, xc;
samplenum = 0;

//Calcs a period number which is est to be stable
//after filter startup costs.  Uses an even numbered
//period (phase), and !<2.
    periodnum = (int)(0.005 * f);
    if(periodnum%2==1){
      periodnum = periodnum+1;
    }
    if (periodnum < 2){
      periodnum = 2;
    }

 switch (type) {
    case MYSIN:
      //Calcs the sample number (samplenum) at the
      //zero crossing (periodnum), above, to avoid
      //any initial corrupted samples by filter code. See td_filtsig.dat.
	for (int s=0;s<SIZE/4;s++) {  //SIZE/4 should be enough
	x1 = inputfiltsine[s];
	x2 = inputfiltsine[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	  samplenum = samplenum++;
	    if (samplenum == periodnum){
	      num = s+1;
	    }
	  }
	}
//force 0.0 at beg, then start at num, go to end of first period.
//period=myksmps
//Notice (in gnuplot) phase of filtered sig is shifted 180 deg 
//from csoundBufUnfiltered sig.
for(j=0;j<=period;j++){
	for(k=0;k<MYCHANNELS;k++){
	  if(j==0){
	  buffer_filt[j][k]=0.0000;//forces start at 0.0
	  }
	  else
//inputfiltsine is available here as a global array
//which is filled by calling timeDomain_filterSignal() above.    
buffer_filt[j][k] =  inputfiltsine[(j-1) + num]; //filtered sine
	    if(k%2==0){
fprintf(outf11, "%5.4f \n", buffer_filt[j][k]);
	    }
	    if(k%2==1){
fprintf(outf10, "%5.4f \n", buffer_filt[j][k]);
	    }
	}//ends k for
      }//ends j for
        break;
    case SAW:
      	for (int s=0;s<SIZE/4;s++) { 
	x1 = inputfiltsawtooth[s];
	x2 = inputfiltsawtooth[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	  samplenum = samplenum++;
	    if (samplenum == periodnum){
	      num = s+1;
	    }
	  }
	}
for(j=0;j<=period;j++){
	for(k=0;k<MYCHANNELS;k++){
	  if(j==0){
	  buffer_filt[j][k]=0.0000;
	  }
	  else 
buffer_filt[j][k] =  inputfiltsawtooth[(j-1) + num]; //filtered sawtooth
	    if(k%2==0){
fprintf(outf11, "%5.4f \n", buffer_filt[j][k]);
	    }
	    if(k%2==1){
fprintf(outf10, "%5.4f \n", buffer_filt[j][k]);
	    }
	}//ends k for
      }//ends j for
        break;
    case SQ:
        for (int s=0;s<SIZE/4;s++) { 
	x1 = inputfiltsquare[s];
	x2 = inputfiltsquare[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	  samplenum = samplenum++;
	    if (samplenum == periodnum){
	      num = s+1;
	    }
	  }
	}
      for(j=0;j<=period;j++){
	for(k=0;k<MYCHANNELS;k++){
	  if(j==0){
	  buffer_filt[j][k]=0.0000;
	  }
	  else 
buffer_filt[j][k] =  inputfiltsquare[(j-1) + num]; //filtered square
	    if(k%2==0){
fprintf(outf11, "%5.4f \n", buffer_filt[j][k]);
	    }
	    if(k%2==1){
fprintf(outf10, "%5.4f \n", buffer_filt[j][k]);
	    }
	}//ends k for
      }//ends j for
        break;
    case TRI:
        for (int s=0;s<SIZE/4;s++) { 
	x1 = inputfilttriangle[s];
	x2 = inputfilttriangle[s+1];
	xc = x1 * x2;
	  if (xc < 0) {
	  samplenum = samplenum++;
	    if (samplenum == periodnum){
	      num = s+1;
	    }
	  }
	}
      for(j=0;j<=period;j++){
	for(k=0;k<MYCHANNELS;k++){
	  if(j==0){
	  buffer_filt[j][k]=0.0000;
	  }
	  else 
buffer_filt[j][k] =  inputfilttriangle[(j-1) + num]; //filtered triangle
	    if(k%2==0){
fprintf(outf11, "%5.4f \n", buffer_filt[j][k]);
	    }
	    if(k%2==0){
fprintf(outf10, "%5.4f \n", buffer_filt[j][k]);
	    }
	}//ends k for
      }//ends j for
        break;
    case NOISEW:
      for(j=0;j<=period;j++){
	for(k=0;k<MYCHANNELS;k++){
	  if(j==0){
	  buffer_filt[j][k]=0.0000;
	  }
	  else 
//since noise is random, should be o.k. to force 0.0 start
//and use one period, which for noise is myksmps=SIZE.
//However if issues arise, see td_filtsig.dat.
buffer_filt[j][k] =  inputfiltwhitenoise[j-1]; //filtered whitenoise
	    if(k%2==0){
fprintf(outf11, "%5.4f \n", buffer_filt[j][k]);
	    }
	    if(k%2==1){
fprintf(outf10, "%5.4f \n", buffer_filt[j][k]);
	    }
	}//ends k for
      }//ends j for
        break;
    case NOISEP:
      for(j=0;j<=period;j++){
	for(k=0;k<MYCHANNELS;k++){
	  if(j==0){
	  buffer_filt[j][k]=0.0000;
	  }
	  else
//since noise is random, should be o.k. to force 0.0 start
//and use one period, which for noise is myksmps=SIZE.
//However if issues arise, see td_filtsig.dat.
buffer_filt[j][k] =  inputfiltpinknoise[j-1]; //filtered pinknoise
	    if(k%2==0){
fprintf(outf11, "%5.4f \n", buffer_filt[j][k]);
	    }
	    if(k%2==1){
fprintf(outf10, "%5.4f \n", buffer_filt[j][k]);
	    }
	}//ends k for
      }//ends j for
        break;
    default:
        break;
    } //end switch
fclose(outf10);
fclose(outf11);
}


//+++++++++++++++MAIN+++++++++++++++
//++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++
int main(int argc, char *argv[])
{
    //Set wave type for file I/O funcs
    //MYSIN,SAW,SQ,TRI,NOISEW,or NOISEP
    int wavetype = SAW;
    
    //Filter variables for BiQuad() and BiQuad_new()
    double dbGain, freq, srate, bandwidth, root;
    dbGain = -3.0; //gain of the filter
    freq = 1000.0; //600 //center frequency of filter
    //srate = 11025.0; //sampling rate
    srate = 44100.0; //sampling rate. 
	    // Change #DEFINE SIZE & N, above,
	    // double D, below, and SR in .csd.
    root = 0.166666667; //12th rt of two
    bandwidth = 12 * root; //bandwidth in octave
    //where (12 * root = 1 octave) and freq edges are
    // edge = freq(ctr freq) * bandwidth,
    // freq + edge, and freq - edge.
//---------------------
 //Sound Sample and FFT variables
    double A = 1.0; //amp scaling factor
    double i = 1; 
    double D =44100; //length and time
//  D/SR=SecPrSample, and SecPrSample*F=1 cycle at given
//  Freq. Thus one 1 cycle = D/SmpPrCycle.
//  at 44.1Khz, 44100/44100=1 sec. pr sample.
//  and 1 * 525 = 525 samples pr 1 cycle at
//  that freq. Thus one cycle = 44100/525= 84
//  samples for the given dur(D) and freq(F).
//  See int myksmps below.
    double f = 1050; //frequency in Hz. Also change in .csd.
      //use: 100 525 1050 1764 2100 2205 4410 8820
//   (Csound: for pitch using spin, the resulting frequency 
//   is the krate (SR/ksmps). The.csd needs whole numbers for
//   the k-rate.  The.csd will play one cycle at the k-rate
//   to reproduce the sound at the freq of the k-rate.
//   myksmps is only the granularity, since that buffer will be
//   performed at the .csd k-rate)
//   SR = ksmps*kr.  kr=SR/ksmps.  ksmps=SR/kr.

//   Thus in the .csd, set SR and kr or ksmps so that
//   the k-rate will be equal to f or Freq above. 
//   Set the var myksmps to the number of samples for
//   one cycle above (D/SmpPrCycle).
//---------------------
  // Csound variables
  boolean unfilt = TRUE; //set for csound ksmps loop as filt or unfilt sig
  boolean filt = FALSE; 
  Csound *sender; //Csound sender instance
  //MYFLT **psend;
  MYFLT kr, scale;
  char sar[20], kar[20], ksmp[20], nchns[20];
  int j,k,res,myframe,ksmps,nchans,frames,
      sr, chans;
  //this is one period of a csound buffer  
  //and is passed to the csoundBufFiltered func.
  int myksmps = D/f;  //84. See doubles D and f, above.
      
  if (wavetype == NOISEW || wavetype == NOISEP){
   //for noise, use the whole SIZE for the csound buffer
   myksmps = SIZE;
  }
  //----------------------------------
    //biquad is the structure in biquad.h
    //send values to the func to setup coefficients
    //LPF, /* low pass filter */
   // HPF, /* High pass filter */
    //BPF, /* band pass filter */
    //NOTCH, /* Notch Filter */
    //PEQ, /* Peaking band EQ filter */
    //LSH, /* Low shelf filter */
    //HSH /* High shelf filter */
    biquad *bq = BiQuad_new(LPF,dbGain,freq, srate,bandwidth);
    //see below for how to call the BiQuad func and
    //pass the ptr to the structure biquad:
    //myfiltnum = BiQuad(sample[j], bq); //ex.
    
//*****************************************
//*****************************************
//To Read Data from an external file
// into the buffer 
//*****************************************
//*****************************************
// FILE *infile;
// infile = fopen("/home/JCH/KdevProjs/CsoundAPI/Spin_AddSpinSample/debug/src/noisedata.dat", "r");
// int m = 0;
// while (!feof(infile))
// {
// fscanf( infile, "%f", &mynum);
// mynoise[m] = mynum;
// ++m; 
// //printf("%f\n", mynum);
// }
// fclose(infile);
//**************

//writes a timedomain signal to a file: td_sig.dat
timeDomain(D,i,f,srate,A,wavetype);

DCoffset_timedomainSignal(f,wavetype); 

//runs timdedomain data thru the biquad filter
//regardless of the csound boolean filter flags above
timeDomain_filterSignal(D,i,f,srate,A, bq, wavetype);

//the filter has startup costs, especially at higher
//frequencies.  DCoffset attempts to remove the offset
//from the filtered timedomain signal
//then saves the signal to a file: td_filtsig.dat
DCoffset_filteredSignal(f,wavetype); 

//this is the frequency response of the filter
//and will save data to a file for plotting: freqresp.dat
//startup transients are observable, especially at
//higher frequencies
BiQuad_response(freq, srate, bq);

// places the non-filt timedomain data in an array
// of SIZE + 2 (padded zeros) for FFT,
// and also places the filtered timedomain data which has been
// thru DC offset to another array of SIZE + 2
prepFFT(D,i,f,srate,A, wavetype, bq);

//APPLY a WINDOW to the TIME DOMAIN signals
//both filtered and non filtered
//and save the windowed data to files: td_filtsigWindowed.dat,
//and td_unfiltsigWindowed.dat
windowSignal(bq);

//performs DFT using FFTW3. 
//Saves data to files as log freqs: fd_freqs.dat
//and as filtered freqs: fd_filtfreq.dat
performDFT(bq);

//+++++++++++++++++++++++++++++++++++++++++
//*****************************************
//*****************************************
//CSOUND.  Create instances and perform ksmps.
//*****************************************
//*****************************************
sender = new Csound;
sender->PreCompile();
  if (wavetype == NOISEW || wavetype == NOISEP){
res = sender->Compile("Spin_noise.csd");
  }
  else {
res = sender->Compile("Spin.csd"); 
  }
//psend = (MYFLT **)sender->GetSpin();
ksmps = sender->GetKsmps();
printf("--ksmps=%d \n", ksmps);
kr = sender->GetKr();
printf("--krate=%f \n", kr);
//sr = sender->GetSr();
chans = sender->GetNchnls();
printf("--numchans=%d \n", chans);
//frames = ksmps/chans;
scale = sender->Get0dBFS();
//scale = 4.8000; //use this only from IDE

// Loads one period (D/f) of the UNFILTERED data into a buffer
// for csound
csoundBufUnfiltered(D,i,f,srate,A,myksmps,wavetype);

//Loads one period (D/f) of time domain FILTERED data into a csound 
//buffer for use in comparison of output of .csd.
csoundBufFiltered(D,i,f,A,myksmps,wavetype);
  
//******************************************
//uses ksmps and chans from the .csd files
//program variables mykmsps and MYCHANNELS
//should agree with the .csd values
double value;
res = sender->PerformKsmps();

 while(!res){
	for(j=0;j<ksmps;j++){
		for(k=0;k<chans;k++){
		  if (unfilt == TRUE){
value = buffer_unfilt[j][k];//unfiltered signal
		  }
		  if (filt == TRUE){
value = buffer_filt[j][k];//filtered signal
		  }
sender->AddSpinSample(j, k, (value *scale));
		}
	}

 if(!res) res = sender->PerformKsmps();

    // It is necessary to clear the spin buffer before calling PerformKsmps again...
MYFLT *spin = sender->GetSpin();
for (size_t sampleI=0, sampleN=ksmps * chans; sampleI < sampleN; ++sampleI) 
	{
      spin[sampleI] = 0.0;
    	}
 }
 delete sender;
//************** 

return (0);
}  //end of main
